#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util>

#define PLUGIN  "CS Revo: Costumes/Fantasias"
#define VERSION "1.0"
#define AUTHOR  "Wilian M."

#define PREFIX_MENUS "\r[CS Revo!]"
#define PREFIX_CHAT "^4[CS Revo!]"

enum xDataCostumes
{
	xCostName[50], xCostModelId, xCostModelAnim
}

enum _:xDataSaveCostumes
{
	xCostModelHead,
	xCostModelBack,
	xCostModelPelvis,
	xCostSaveHead,
	xCostSaveBack,
	xCostSavePelvis
}

new xCostDataHead[][xDataCostumes] =
{
	{ "Aura de Anjo", 0, 2 },
	{ "Orelhas de gato", 0, 7 },
	{ "Chifres do diabo", 0, 10 },
	{ "Cabeça do urso polar", 0, 20 },
	{ "Orelhas de coelho", 0, 1 },
	{ "Chapéu japones", 0, 15 },
	{ "Máscara faraó", 1, 2 },
	{ "Cabeça de Abóbora", 0, 22 },
	{ "Cabeça de boneco de neve", 0, 23 },
	{ "Orelhas de Porco", 0, 19 },
	{ "Orelhas de Panda", 0, 18 },
	{ "Cabeça do Bazzi", 0, 3 },
	{ "Cabeça do Dao", 0, 9 },
	{ "Orelhas do Esquilo", 0, 24 },
	{ "Warbonnet indiano", 0, 14 },
	{ "Cara indiana", 1, 4 },
	{ "Cabeça de dinossauro", 0, 11 },
	{ "Máscara do Cavaleiro das Trevas", 0, 26 },
	{ "Coroa do Paladino", 0, 27 },
	{ "Tiara de morcego caçador carmesim", 0, 6 },
	{ "Máscara Dourada", 0, 13 },
	{ "Cabelo afro", 0, 0 },
	{ "Cabelo elegante", 0, 8 },
	{ "Provocação Apple", 0, 21 },
	{ "Bigode de cavalheiro", 0, 12 },
	{ "Óculos de sol idol", 1, 3 },
	{ "Chapelaria de boxe", 0, 4 },
	{ "Capacete de super-herói", 0, 25 },
	{ "Rosto do Crono Athletic", 1, 1 },
	{ "Máscara do Jack's", 1, 5 },
	{ "Oberon's Bomb Hair Band", 0, 17 },
	{ "Chifre do Oberon", 0, 16 }
}

new xCostDataBack[][xDataCostumes] =
{
	{ "Asas de anjo", 2, 0 },
	{ "Cat Tuna", 2, 2 },
	{ "Asas do diabo", 2, 4 },
	{ "Boneca Pinguim", 2, 16 },
	{ "Boneca Múmia", 2, 6 },
	{ "Garoto Fantasma", 2, 18 },
	{ "Meias de Natal", 2, 19 },
	{ "Garfo de porco", 2, 15 },
	{ "Boneca Panda", 2, 14 },
	{ "Bolota", 2, 20 },
	{ "Relógio", 2, 23 },
	{ "Bandeira chinesa", 3, 0 },
	{ "Escudo Indiano", 2, 12 },
	{ "Fantoche de dinossauro", 2, 5 },
	{ "Escudo dourado", 2, 9 },
	{ "Provocation Target", 2, 17 },
	{ "Bastão de cavalheiro", 2, 8 },
	{ "Idol Microphone", 2, 11 },
	{ "Mochila Super-Herói", 2, 21 },
	{ "Saco do Caranguejo Tirano", 2, 3 },
	{ "Mr. X's shell", 3, 1 },
	{ "Asas da asa de Crono", 3, 2 },
	{ "Asas da asa Laser", 2, 10 },
	{ "Morcego do Terror Congelado", 2, 7 },
	{ "Bazuca de Kraken", 2, 13 },
	{ "Boneca Titã", 2, 22 },
	{ "Asas de Angra", 2, 1 }
}

new xCostDataPelvis[][xDataCostumes] =
{
	{ "Cauda de gato", 4, 1 },
	{ "Cauda do Diabo", 4, 3 },
	{ "Rabo de porco", 4, 7 },
	{ "Cauda de panda", 4, 6 },
	{ "Cinturão Indiano", 4, 5 },
	{ "Cauda de lobo do licantropo", 4, 0 },
	{ "Relógio de mão de cavalheiro", 4, 4 },
	{ "Cinturão de Campeão de Boxe", 4, 10 },
	{ "Engrenagem de manobra 3D", 4, 2 }
}

new xCostPrecModels[][] =
{
	"models/fantasias/head.mdl",
	"models/fantasias/head2.mdl",
	"models/fantasias/back.mdl",
	"models/fantasias/back2.mdl",
	"models/fantasias/pelvis.mdl"
}

new xSelectCostMode[33], xAction[33], xVarsCostId[33][xDataSaveCostumes]
new xSaveNameCost[33][xDataSaveCostumes][50], xCvarOnlyAdmin

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	xCvarOnlyAdmin = register_cvar("csr_costumes_only_adm", "0")

	xRegisterSay("costumes", "xShowCostumes")
	xRegisterSay("fantasia", "xShowCostumes")
	xRegisterSay("fantasias", "xShowCostumes")
	xRegisterSay("hats", "xShowCostumes")
	xRegisterSay("hat", "xShowCostumes")
	xRegisterSay("chapeu", "xShowCostumes")
	xRegisterSay("chapeus", "xShowCostumes")
}

public client_disconnected(id)
{
	xSelectCostMode[id] = false
	xAction[id] = false
	xVarsCostId[id][xCostModelHead] = false
	xVarsCostId[id][xCostModelBack] = false
	xVarsCostId[id][xCostModelPelvis] = false
	xSaveNameCost[id][xCostSaveHead] = "^0"
	xSaveNameCost[id][xCostSaveBack] = "^0"
	xSaveNameCost[id][xCostSavePelvis] = "^0"
}

public plugin_precache()
{
	new i

	for(i = 0; i < sizeof(xCostPrecModels); i++)
		precache_model(xCostPrecModels[i])
}

public xShowCostumes(id)
{
	if(!(get_user_flags(id) & ADMIN_RESERVATION) && get_pcvar_num(xCvarOnlyAdmin))
	{
		client_print_color(id, print_team_default, "%s ^3Fantasias apenas para ^1vips.", PREFIX_CHAT)

		return PLUGIN_HANDLED
	}

	new xFmtx[512]

	formatex(xFmtx, charsmax(xFmtx), "%s \wEscolha sua fantasia", PREFIX_MENUS)

	new xMenu = menu_create(xFmtx, "_xShowCostumes")
	
	formatex(xFmtx, charsmax(xFmtx), "Cabeça \d[\r%s\d]", strlen(xSaveNameCost[id][xCostSaveHead]) > 0 ? xSaveNameCost[id][xCostSaveHead] : "Nada selecionado")
	menu_additem(xMenu, xFmtx)

	formatex(xFmtx, charsmax(xFmtx), "Costas \d[\r%s\d]", strlen(xSaveNameCost[id][xCostSaveBack]) > 0 ? xSaveNameCost[id][xCostSaveBack] : "Nada selecionado")
	menu_additem(xMenu, xFmtx)

	formatex(xFmtx, charsmax(xFmtx), "Rabo \d[\r%s\d]^n", strlen(xSaveNameCost[id][xCostSavePelvis]) > 0 ? xSaveNameCost[id][xCostSavePelvis] : "Nada selecionado")
	menu_additem(xMenu, xFmtx)

	menu_additem(xMenu, "\yRemover fantasias")

	menu_setprop(xMenu, MPROP_EXITNAME, "Sair")
	
	menu_display(id, xMenu)

	return PLUGIN_CONTINUE
}

public _xShowCostumes(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)

		return PLUGIN_HANDLED
	}

	switch(item)
	{
		case 0:
		{
			xSelectCostMode[id] = 1

			xSelectCostume(id)
		}

		case 1:
		{
			xSelectCostMode[id] = 2

			xSelectCostume(id)
		}

		case 2:
		{
			xSelectCostMode[id] = 3

			xSelectCostume(id)
		}

		case 3:
		{
			xResetCostume(id, 1)
			xResetCostume(id, 2)
			xResetCostume(id, 3)
			client_print_color(id, print_team_default, "%s ^3Fantasias removidas.", PREFIX_CHAT)
		}
	}

	return PLUGIN_HANDLED
}

public xSelectCostume(id)
{
	new xFmtx[512], xKey[24], i

	if(xSelectCostMode[id] == 1) formatex(xFmtx, charsmax(xFmtx), "%s \wFantasias para a \yCabeça", PREFIX_MENUS)
	if(xSelectCostMode[id] == 2) formatex(xFmtx, charsmax(xFmtx), "%s \wFantasias para a \yCostas", PREFIX_MENUS)
	if(xSelectCostMode[id] == 3) formatex(xFmtx, charsmax(xFmtx), "%s \wFantasias para o \yRabo", PREFIX_MENUS)

	new xMenu = menu_create(xFmtx, "_xSelectCostume")

	switch(xSelectCostMode[id])
	{
		case 1:
		{
			for(i = 0; i < sizeof(xCostDataHead); i++)
			{
				formatex(xFmtx, charsmax(xFmtx), "%s", xCostDataHead[i][xCostName])
				num_to_str(i, xKey, charsmax(xKey))
				menu_additem(xMenu, xFmtx, xKey)
			}
		}

		case 2:
		{
			for(i = 0; i < sizeof(xCostDataBack); i++)
			{
				formatex(xFmtx, charsmax(xFmtx), "%s", xCostDataBack[i][xCostName])
				num_to_str(i, xKey, charsmax(xKey))
				menu_additem(xMenu, xFmtx, xKey)
			}
		}

		case 3:
		{
			for(i = 0; i < sizeof(xCostDataPelvis); i++)
			{
				formatex(xFmtx, charsmax(xFmtx), "%s", xCostDataPelvis[i][xCostName])
				num_to_str(i, xKey, charsmax(xKey))
				menu_additem(xMenu, xFmtx, xKey)
			}
		}
	}

	menu_setprop(xMenu, MPROP_BACKNAME, "Voltar")
	menu_setprop(xMenu, MPROP_NEXTNAME, "Proxima")
	menu_setprop(xMenu, MPROP_EXITNAME, "Sair")
	menu_display(id, xMenu)
}

public _xSelectCostume(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)

		return PLUGIN_HANDLED
	}

	new data[6], iname[64], access, callback, xFmtx[50]
	menu_item_getinfo(menu, item, access, data, charsmax(data), iname, charsmax(iname), callback)

	xAction[id] = str_to_num(data)

	switch(xSelectCostMode[id])
	{
		case 1:
		{
			xResetCostume(id, 1)
			xMakeCostume(id, xCostPrecModels[xCostDataHead[xAction[id]][xCostModelId]], 1, xCostDataHead[xAction[id]][xCostModelAnim])
			client_print_color(id, print_team_default, "%s ^3Você está usando a fantasia: ^1%s ^3[Cabeça].", PREFIX_CHAT, xCostDataHead[xAction[id]][xCostName])
			
			formatex(xFmtx, charsmax(xFmtx), "%s", xCostDataHead[xAction[id]][xCostName])

			xSaveNameCost[id][xCostSaveHead] = xFmtx
		}

		case 2:
		{
			xResetCostume(id, 2)
			xMakeCostume(id, xCostPrecModels[xCostDataBack[xAction[id]][xCostModelId]], 2, xCostDataBack[xAction[id]][xCostModelAnim])
			client_print_color(id, print_team_default, "%s ^3Você está usando a fantasia: ^1%s ^3[Costas].", PREFIX_CHAT, xCostDataBack[xAction[id]][xCostName])

			formatex(xFmtx, charsmax(xFmtx), "%s", xCostDataBack[xAction[id]][xCostName])

			xSaveNameCost[id][xCostSaveBack] = xFmtx
		}

		case 3:
		{
			xResetCostume(id, 3)
			xMakeCostume(id, xCostPrecModels[xCostDataPelvis[xAction[id]][xCostModelId]], 3, xCostDataPelvis[xAction[id]][xCostModelAnim])
			client_print_color(id, print_team_default, "%s ^3Você está usando a fantasia: ^1%s ^3[Rabo].", PREFIX_CHAT, xCostDataPelvis[xAction[id]][xCostName])

			formatex(xFmtx, charsmax(xFmtx), "%s", xCostDataPelvis[xAction[id]][xCostName])

			xSaveNameCost[id][xCostSavePelvis] = xFmtx

		}
	}

	xShowCostumes(id)

	return PLUGIN_HANDLED
}

public xMakeCostume(id, model[], part, anim)
{
	switch(part)
	{
		case 1:
		{
			xVarsCostId[id][xCostModelHead] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	

			set_pev(xVarsCostId[id][xCostModelHead], pev_movetype, MOVETYPE_FOLLOW)
			set_pev(xVarsCostId[id][xCostModelHead], pev_aiment, id)
			set_pev(xVarsCostId[id][xCostModelHead], pev_rendermode, kRenderNormal)
			engfunc(EngFunc_SetModel, xVarsCostId[id][xCostModelHead], model)
			set_pev(xVarsCostId[id][xCostModelHead], pev_body, anim)
			set_pev(xVarsCostId[id][xCostModelHead], pev_sequence, anim)
			set_pev(xVarsCostId[id][xCostModelHead], pev_animtime, get_gametime())
			set_pev(xVarsCostId[id][xCostModelHead], pev_framerate, 1.0)
		}

		case 2:
		{
			xVarsCostId[id][xCostModelBack] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	

			set_pev(xVarsCostId[id][xCostModelBack], pev_movetype, MOVETYPE_FOLLOW)
			set_pev(xVarsCostId[id][xCostModelBack], pev_aiment, id)
			set_pev(xVarsCostId[id][xCostModelBack], pev_rendermode, kRenderNormal)
			engfunc(EngFunc_SetModel, xVarsCostId[id][xCostModelBack], model)
			set_pev(xVarsCostId[id][xCostModelBack], pev_body, anim)
			set_pev(xVarsCostId[id][xCostModelBack], pev_sequence, anim)
			set_pev(xVarsCostId[id][xCostModelBack], pev_animtime, get_gametime())
			set_pev(xVarsCostId[id][xCostModelBack], pev_framerate, 1.0)
		}

		case 3:
		{
			xVarsCostId[id][xCostModelPelvis] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	

			set_pev(xVarsCostId[id][xCostModelPelvis], pev_movetype, MOVETYPE_FOLLOW)
			set_pev(xVarsCostId[id][xCostModelPelvis], pev_aiment, id)
			set_pev(xVarsCostId[id][xCostModelPelvis], pev_rendermode, kRenderNormal)
			engfunc(EngFunc_SetModel, xVarsCostId[id][xCostModelPelvis], model)
			set_pev(xVarsCostId[id][xCostModelPelvis], pev_body, anim)
			set_pev(xVarsCostId[id][xCostModelPelvis], pev_sequence, anim)
			set_pev(xVarsCostId[id][xCostModelPelvis], pev_animtime, get_gametime())
			set_pev(xVarsCostId[id][xCostModelPelvis], pev_framerate, 1.0)
		}
	}
}

public xResetCostume(id, number)
{
	switch(number)
	{
		case 1:
		{
			fm_set_entity_visibility(xVarsCostId[id][xCostModelHead], 0)
			xVarsCostId[id][xCostModelHead] = 0
			xSaveNameCost[id][xCostSaveHead] = "^0"
		}
		case 2:
		{
			fm_set_entity_visibility(xVarsCostId[id][xCostModelBack], 0)
			xVarsCostId[id][xCostModelBack] = 0
			xSaveNameCost[id][xCostSaveBack] = "^0"
		}
		case 3:
		{
			fm_set_entity_visibility(xVarsCostId[id][xCostModelPelvis], 0)
			xVarsCostId[id][xCostModelPelvis] = 0
			xSaveNameCost[id][xCostSavePelvis] = "^0"
		}
	}
}

stock xRegisterSay(szsay[], szfunction[])
{
	new sztemp[64]
	formatex(sztemp, 63 , "say /%s", szsay)
	register_clcmd(sztemp, szfunction)
	
	formatex(sztemp, 63 , "say .%s", szsay)
	register_clcmd(sztemp, szfunction)
	
	formatex(sztemp, 63 , "say_team /%s", szsay)
	register_clcmd(sztemp, szfunction )
	
	formatex(sztemp, 63 , "say_team .%s", szsay)
	register_clcmd(sztemp, szfunction)
}